<template>
	<Page class="page">
		<ActionBar class="action" title="Octanium | Mantenimiento">
			<NavigationButton
			:icon="classMenu"
			@tap="openCloseDrawer()"/>

			<ActionItem @tap="logOut"
      		android.systemIcon="ic_menu_more"
			text="logOut"
			android.position="popup">
			</ActionItem>
		</ActionBar>
		<RadSideDrawer ref="drawer" @drawerOpened="sideActive==true" @drawerClosed="sideActive=false">
			<StackLayout ~drawerContent>
				<ListSideDrawer height="100%" @closeDrawerTap="openCloseDrawer()"></ListSideDrawer>
			</StackLayout>
			<StackLayout ~mainContent>	
				<StackLayout>
					<ScrollView>					
						<GridLayout rows="auto,*,*">
							<StackLayout>
								<Button v-show="!processing" :text="'\uf030'+' Reportar Incidencia'" class="button btn btn-primary fa" marginTop="20" @tap="tomarFoto"></Button>
								<Label 
								text="Galeria de incidencias" 
								class="boring"
								:style="{'text-align': 'center', 'font-size': '18px'}" 
								textWrap="true"
								backgroundColor="#ffffff">
								</Label>		
								<Label
									v-show="!processing"
									v-if="itemList.length == 0"
									text="Sin fotos aun. !!!"
									textWrap="true"
									:style="{'text-align': 'center'}"
									backgroundColor="#ffffff">
								</Label>
								<RadListView 
								v-if="itemList.length != 0"
								for="item in itemList"
								layout="grid"
								:gridSpanCount="3"
								backgroundColor="rgba(255, 255, 255, 0.7)"
								height="450dpi"
								@itemTap="onItemTap">
									<v-template>
										<StackLayout orientation="vertical" class="item">
											<GridLayout rows="auto,auto">
												<Image :src="item.foto" stretch="fill"/>
												<Label
												:text="'Descripcion:\n'+item.descripcion"
												textWrap="true"
												:style="{'text-align': 'center'}"
												backgroundColor="rgba(255, 255, 255, 0.7)"
												row="1">
												</Label>
											</GridLayout>
										</StackLayout>
									</v-template>
								</RadListView>
							</StackLayout>
							<ActivityIndicator :busy="processing" color="#7d00cc" row="0" rowSpan="3"></ActivityIndicator>
						</GridLayout>
					</ScrollView>
				</StackLayout>
			</StackLayout>
		</RadSideDrawer>
	</Page>
</template>

<script>
// components
import Login from "./Login";
import ListSideDrawer from '../components/ListSideDrawer';
import Incidence from "../components/incidencias/Incidence";
import ModalShowIncidence from "../components/incidencias/ModalShowIncidence";
import ModalEditIncidence from "../components/incidencias/ModalEditIncidence";
import ModalDeleteIncidence from "../components/incidencias/ModalDeleteIncidence";
import ModalActRiesgo from "../components/incidencias/ModalActRiesgo";
import ModalActRutina from "../components/incidencias/ModalActRutina";
// libraries
import * as camera from "nativescript-camera";
import {ImageSource} from "tns-core-modules/image-source";
import axios from 'axios';
import { urlApi, EventBus } from '../main.js';
import { mapGetters } from 'vuex';
import * as dialogs from "tns-core-modules/ui/dialogs";
import moment from 'moment';
import * as Toast from 'nativescript-toast';
import store from '../store';

const ModalCalendarizar = {
	props: ['item'],
	data(){
		return{
			fecha: new Date(),
			minDate: null,
			maxDate: null
		}
	},
    template: `
	  <Page>
		<StackLayout>
			<DatePicker v-model="fecha" :minDate="minDate" :maxDate="maxDate" />
			<StackLayout orientation="horizontal">
				<Button @tap="$modal.close({calendarizar: false, fecha: null})" text="Cancelar"/>                    
				<Button @tap="onTap" text="Calendarizar"/>
			</StackLayout>
		</StackLayout>
      </Page>
    `,
    created() {
		this.minDate = new Date();
		this.maxDate = new Date(this.minDate.getFullYear(), 11, 31);
	},
	methods:{
		onTap(){
			this.$modal.close({calendarizar: true, fecha: this.fecha})
		}
	}
};
export default {
	created() {
		this.obtenerFotos();
		EventBus.$off();
		EventBus.$on('saved', (incidencia) =>{
			if(incidencia.tipo_mantenimiento_id == 1 && this.user.role ==3 ){
				this.obtenerFotos();
				console.log('actualizado');
			}else{
				this.onSave(incidencia,  this.user.id);
			}
		});
		// si el usuario es supervisor
		// si tipo mant == riesgo(1)
			// actualizar lista de incidencias
			// listar proveedores persona moral y depues fisica proveedor y empresa
			// guardar
		// si tipo mant == rutina(2)
			// actualizar lista de incidencias
			// listar usuarios de la misma empresa
			// guardar
	},
	beforeDestroy(){
		console.log('destroyed!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
		EventBus.$off();
	},
	data() {
		return {
			processing: false,
			sideActive:false,
			isActive: false,
			data: {},
			itemList:[]
		}
	},
	computed:{
		classMenu(){
			return this.sideActive ? 'res://ic_menu_close':'res://ic_menu_w';
		},
		...mapGetters({
			items: 'getItems',
			user: 'getUser'
		})
	},
	methods: {
        showIncidence(photo) {
            this.$navigateTo(Incidence, {				
				props: { 
					photo: photo
				}
            });
		},
		tomarFoto() {
            // See the options at https://github.com/NativeScript/nativescript-camera#using-the-options-to-take-memory-efficient-picture
            // for more information on how to customize the pictures you take.
            camera.takePicture({ width: 300, height: 300, keepAspectRatio: true })
                .then(imageAsset => {
                    let source = new ImageSource();
                    let pictureFromCamera = imageAsset;
                    source.fromAsset(imageAsset).then(res => {
                        let base64 = res.toBase64String("png");
                        let pictureBase64 = "data:image/png;base64," + base64;
                        this.showIncidence({
							picture_base_64: pictureBase64 
						});
                    })
                })
                .catch(err => {
                    console.log("Error -> " + err.message);
                });
        },
		obtenerFotos(listaPulled){
			this.processing = true;
			axios.get(urlApi+'/api/v1/mtto/incidences/listado')
			.then(respuesta => {
				this.processing = false;
				this.itemList = respuesta.data;				
			})
			.catch(error =>{
				console.log(error);
				
			});
		},
    onItemTap({ item }){
			dialogs.action({
				message: "Opciones:",
				cancelButtonText: "Cancelar",
				actions: this.user.role==4?["Visualizar","Editar","Calendarizar","Eliminar"]:["Visualizar","Editar", "Eliminar"]
			}).then(result => {
				if(result == "Visualizar"){
					this.$showModal(ModalShowIncidence, {
					    props: {item:item}
					});
				}else if(result == "Editar"){
					this.$showModal(ModalEditIncidence, {
					    props: {item:item}
					}).then(data => {
					    if(data)
					        this.obtenerFotos();
					});
				}else if(result == "Eliminar"){
					this.$showModal(ModalDeleteIncidence, {
					    props: {item:item}
					}).then(data => {
					    if(data)
					        this.obtenerFotos();
					});
					
				}else if(result == "Calendarizar"){
					if( item.maintenance.tipo_mantenimiento_id == 1 ){
						this.$showModal(ModalActRiesgo)
						.then(data => {
							if(data.calendarizar){
								this.calendarizar(item.maintenance, data.fecha , data.usuario);
							}
						});
					}else{
						this.$showModal(ModalActRutina)
						.then(data => {
							if(data.calendarizar){
								this.calendarizar(item.maintenance, data.fecha , data.usuario);
							}
						});
					}
				}
			});
        },
		logOut(){
			this.$store.dispatch('logOut')
			.then(resp=>{
				this.$navigateTo(Login);
			});
		},
		openCloseDrawer() {
			if(this.sideActive == false){
				this.$refs.drawer.nativeView.showDrawer();
				this.sideActive = true; 
			}else{
				this.$refs.drawer.nativeView.closeDrawer();
				this.sideActive = false; 
			}
		},
		onSave(incidence, usuario){
			this.obtenerFotos();
			if( this.user.role == 4 ){
				if( incidence.tipo_mantenimiento_id == 1 ){
					this.$showModal(ModalActRiesgo)
					.then(data => {
						if(data.calendarizar){
							this.calendarizar(incidence, data.fecha , data.usuario);
						}
					});
				}else{
					this.$showModal(ModalActRutina)
					.then(data => {
						if(data.calendarizar){
							this.calendarizar(incidence, data.fecha , data.usuario);
						}
					});
				}
			}else{
				dialogs.action({
					message: "Opciones:",
					cancelButtonText: "Cancelar",
					actions: ["Realizar","Calendarizar"]
				}).then(result => {				
					if(result == "Realizar"){
						console.log('usr: ',usuario);
						this.calendarizar(incidence, new Date(), usuario);					
					}else if(result == "Calendarizar"){
						this.$showModal(ModalCalendarizar, {
							props: {item:1}
						}).then(data => {
							if(data.calendarizar){
								this.calendarizar(incidence, data.fecha , usuario);
							}
						});
					}
				});
			}			
		},
		calendarizar(incidencia, fecha, usuario){
			var date =  moment(fecha).format("DD-MM-YYYY"+" 12:00:00");
			console.log('date: ', date);
			axios.post(urlApi+'/api/v1/mtto/logs',{
				periodo_id: 1,
				actividad_id: incidencia.id,
				fecha_calendarizada: date,
				fecha_termino: date
			})
			.then(response=>{
				var actividad = response.data[response.data.length-1].id;

				axios.patch(urlApi+`/api/v1/mtto/actividad/${actividad}/assignment/`,{
					user_id: usuario
				})
				.then(response=>{
					Toast.makeText(`actividad calendarizada satisfactoriamente`,"long").show();
					// this.$destroy();
				})
				.catch(error=>{
					console.log('Error asignacion: '+error);
				});
			})
			.catch(error=>{
				console.log('Error: '+error);
			});
		}
	},
	components: { ListSideDrawer}
}
</script>

<style scoped>
	.header{
		color: white;
		background-color: #490d66;
		margin-bottom: 10;
		padding: 15 0;
	}
	
	.button{
        margin-bottom: 10px;
        display: inline-block;
        text-decoration: none;
        font-weight: bold;
        padding: 60px 60px;
        background-color: #7d00cc;
    }

	.item{
		margin: 10 10 10 10;
	}

	.boring{  
		border-width: 0 0 2 0;
		border-color: rgba(0, 0, 0, 0.3);
	}
</style>
